# StrIO - string buffer IO class
# written by MOROHOSHI Akihiko <moro@nii.ac.jp>
# $Id: str_io.rb,v 1.1 2001/07/27 14:15:49 moro Exp $

class StrIO
    def initialize
	@buf = []
	@str = nil
    end
    def print (*args)
	@buf << args.to_s.freeze
	@str = nil
    end
    def to_s
	if @str
	    @str
	else
	    @str = @buf.join('').freeze
	    @buf = [@str]
	end
	@str
    end
    def to_str
	to_s
    end
    def each(&blk)
	to_s.scan(/.*?\n/, &blk)
    end
end
